unit dropsource_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShlObj, ActiveX, Menus, CheckLst, FWOleDragDrop;

type
  TDropSourceMainForm = class(TForm)
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    CheckListBox1: TCheckListBox;
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure CheckListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    // ,       (  )
    FDropStarted: Boolean;
    //      
    procedure OnGetContent(Sender: TObject;
      const FileDescriptor: TFileDescriptor; Data: TStream);
    //     
    procedure OnDropEnd(Sender: TObject);
  end;

var
  DropSourceMainForm: TDropSourceMainForm;

implementation

{$R *.dfm}

//
//     ,      
// =============================================================================
procedure TDropSourceMainForm.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to CheckListBox1.Count - 1 do
    CheckListBox1.Checked[I] := True;
end;

//
//    
// =============================================================================
procedure TDropSourceMainForm.CheckListBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  I: Integer;
  DropSource: TFWDragDropSourceProvider;
begin
  // ,       -     
  if FDropStarted then Exit;
  //     ,         
  if not (ssLeft in Shift) then Exit;
  //    
  FDropStarted := True;
  //  ,   
  DropSource := TFWDragDropSourceProvider.Create;
  //   -   
  DropSource.ShowUIDialog := True;
  //  ,        ( )
  DropSource.OnGetContent := OnGetContent;
  //    
  DropSource.OnDropEnd := OnDropEnd;
  //    ,    
  for I := 0 to CheckListBox1.Count - 1 do
    if CheckListBox1.Checked[I] then
      DropSource.AddFile(CheckListBox1.Items[I]);
  //    
  DropSource.ExecuteDragDrop;
end;

//
//     (  ,   )
// =============================================================================
procedure TDropSourceMainForm.OnDropEnd(Sender: TObject);
begin
  FDropStarted := False;
end;

//
//         
// =============================================================================
procedure TDropSourceMainForm.N1Click(Sender: TObject);
var
  I: Integer;
  CopySource: TFWCopyDataProvider;
begin
  //  ,   
  CopySource := TFWCopyDataProvider.Create;
  //   -   
  CopySource.ShowUIDialog := True;
  //  ,        ( )
  CopySource.OnGetContent := OnGetContent;
  //    ,    
  for I := 0 to CheckListBox1.Count - 1 do
    if CheckListBox1.Checked[I] then
      CopySource.AddFile(CheckListBox1.Items[I]);
  //      ,      
  CopySource.CopyToClibboard;
end;

//
//        
// =============================================================================
procedure TDropSourceMainForm.OnGetContent(Sender: TObject;
  const FileDescriptor: TFileDescriptor; Data: TStream);
var
  I: Integer;
  R: TResourceStream;
begin
  // -     
  //  ,    
  for I := 0 to 4 do
    if PChar(@FileDescriptor.cFileName[0]) = CheckListBox1.Items[I] then
    begin
      R := TResourceStream.Create(HInstance, 'RES' + IntToStr(I + 1),
        'DRAG_RES');
      try
        Data.CopyFrom(R, 0);
      finally
        R.Free;
      end;
    end;
end;

end.
